function x = metro_haste(image, x0, s, N)

x = zeros(2,N);
xk = x0;
pk = lookup(image, xk);
for k = 1:N
    dx = (randn(2,1) + .1) * s;
    xp = xk + dx;
    pp = lookup(image,xp);
    if rand() < pp / pk * prod(normpdf(dx/s + .1))/prod(normpdf(dx/s - .1));
        xk = xp;
        pk = pp;
    end
    x(:,k) = xk;
end

function p = lookup(image, x)

i = round(x(1));
j = round(x(2));

if i < 1 || i > size(image,1) || j < 1 || j > size(image,2)
    p = 0;
else
    p = double(image(i,j));
end